<?
class ticket extends yadev4php_model {

  // define Ticket 
  // Prolog

  /** type:integer, index:primaryKey, value:auto */
  protected $id;

  /** type:String, caption:Ticketnummer */
  protected $lnummer;
  /** type:datetime, caption:Datum */
  protected $datum;
  /** type:String, caption:Zeit */
  protected $zeit;
  /** type:integer, foreign_model:status, foreign_key:id, foreign_value:kurz, caption:Status, logging:true  */
  protected $fk_status;
  /** type:integer, foreign_model:servicecenter, foreign_key:id, foreign_value:kurz, caption:ServiceCenter  */
  protected $fk_servicecenter;
  /** type:integer, foreign_model:objekt, foreign_key:id, foreign_value:kurz, caption:Objekt  */
  protected $fk_objekt;
  /** type:integer, foreign_model:nutzer, foreign_key:id, foreign_value:kurz, caption:Nutzer  */
  protected $fk_nutzer;
  /** type:integer, foreign_model:anwender, foreign_key:id, foreign_value:zuname-vorname, caption:Ersteller  */
  protected $fk_ersteller;


  /** type:String */
  protected $vorname;
  /** type:String */
  protected $zuname;
  /** type:String */
  protected $telefon;
  /** type:String */
  protected $email;
  /** type:String, foreign_model:erreichbarkeit, foreign_key:kurz, foreign_value:kurz, caption:Erreichbarkeit, validate:notNull()  */
  protected $erreichbarkeit;

  /** type:String, foreign_model:art, foreign_key:kurz, foreign_value:kurz, caption:art, validate:notNull()  */
  protected $art;
  /** type:integer, foreign_model:bauteil, foreign_key:id, foreign_value:kurz, caption:bauteil  */
  protected $fk_bauteil;
  /** type:String */
  protected $stockwerk;
  /** type:String */
  protected $raum;
  /** type:text, validate=notNull(), caption:Beschreibung, logging:short */
  protected $beschreibung;

  /** type:integer, foreign_model:dienstleister, foreign_key:id, foreign_value:kurz, caption:dienstleister, logging:true  */
  protected $fk_dienstleister;
  /** type:date, caption:Weiterleitung Datum, logging:true */
  protected $wldatum;
  /** type:date, caption:Erledigt bis Datum, logging:true */
  protected $ebdatum;
  /** type:date, caption:Verschoben auf Datum, logging:true */
  protected $evdatum;
  /** type:date, caption:Erledigung Datum. logging:true */
  protected $edatum;
  /** type:text, caption:Intern, logging:short */
  protected $intern;
  /** type:text, caption:Bearbeitung, logging:short */
  protected $bearbeitung;
  /** type:string, foreign_model:thema, foreign_key:kurz, foreign_value:kurz, caption:Thema, logging:value  */
  protected $thema;

  /** type:text */
  protected $history;
  


  function get_ID($zeit = "") {
	  if ($zeit == "") $zeit = time();


          $q = ceil(date('n', $zeit) / 3);
	  $y = date('Y',$zeit);

          $like = $_SESSION['objekt_prefix']."-".$y.'/Q'.$q;

	  $sql = "select max(lnummer) as zuletzt  FROM ".$this->_getFrom(true)." where lnummer like '".$like."%'";
	  $result = $this->_db->select($sql);
	  if (!$result === false) {
		$result = $result->fetchAll(PDO::FETCH_ASSOC);
		$alt = $result[0]['zuletzt'];
		$zahl = substr($alt, -3);
		$zahl = (int)$zahl;
		$zahl = $zahl + 1;
		$zahl = str_pad($zahl, 3, "0", STR_PAD_LEFT);
		return $like.'-'.$zahl;
	  }
	  else {
		return $like."-001";
	  }
  }

}
?>
