<? session_start();
header("Expires: Mon, 26 Jul 1997 05:00:00 GMT");
header("Last-Modified: ".gmdate("D, d M Y H:i:s")." GMT");
header("X-UA-Compatible: IE=IE8");

error_reporting(E_ALL);  
ini_set("display_errors", isset($_GET['db']) ? $_GET['db'] : '0');   


$basis = realpath("./");				// Basisverzeichnis von yadev4php
$path = $_SERVER['PATH_INFO'];		  // pfad = Teil der URL nach index.php
$fh = NULL;							 // file handle for autoload workaround

// include framework configuration file
include_once $basis."/config/config.php";



// redirect to new path
function redirController($new_controller = "", $new_method = "", $param = "") {
  GLOBAL $application;
  GLOBAL $language;
  GLOBAL $controller;
  GLOBAL $method;
  
  if ($new_controller == "") $new_controller = $controller;
  if ($new_method == "") $new_method = $method;

  $r = $applikation."/".$language."/".$controller."/".$method."/?".$param;
  
  if (substr($_SERVER['PHP_SELF'],-1) != "/") {
	$r = "/".$r;
  }
  header("HTTP/1.1 301 Moved Permanently");
  header("Location: https://".$_SERVER['SERVER_NAME'].$_SERVER['PHP_SELF'].$r);
  die();

}

// function fr Redirect auf default Werte...
function redir($r) {
  // wenn der aktuelle Pfad nicht auf "/" endet, dann einen "/" vor $r stellen
  if (substr($_SERVER['SCRIPT_NAME'],-1) != "/") {
	$r = "/".$r."?".$_SERVER['QUERY_STRING'];
  }
  header("HTTP/1.1 301 Moved Permanently");
  header("Location: https://".$_SERVER['SERVER_NAME'].$_SERVER['SCRIPT_NAME'].$r);
  die();
}


// *********** Start **********
// Pfad in seine Bestandteile aufteilen
list($dummy,$application, $language, $controller, $method, $file) = split("/", $path, 6);

// wenn keine Datei angegeben wurde und der Pfad nicht auf "/" endet, dann
// auf Pfad + "/" umleiten. ("" wird von redir automatisch auf "/" erweitert)
if ($file == "" && substr($path,-1) != "/") {
  redir("$application/$language/$controller/$method/");
}

// ersetzte fehlende Angaben durch defaults
if ($application == "") redir("$default_application/$default_language/$default_controller/$default_method/");
elseif ($language == "") redir("$application/$default_language/$default_controller/$default_method/");
elseif ($controller == "") redir("$application/$language/$default_controller/$default_method/");
elseif ($method == "") redir("$application/$language/$controller/$default_method/");


$tpl_path = $basis."/applications/".$application."/views/";
set_include_path(get_include_path() . PATH_SEPARATOR . $tpl_path);


// Include config file for application
include_once $basis."/applications/".$application."/config/config.php";

// wenn kein user angemeldet ist, dann ein redir auf die Anmeldeseite
if ($_SESSION['anwender_id'] == '' && $controller != 'c_login' && $config_application['Login'] == true) {

  redir ("$application/$language/c_login/main/?from=".urlencode(substr($path,1)."?".$_SERVER['QUERY_STRING']));
}



// wenn eine Datei z.B. eine Grafik, angefordert wurde,
// dann diese als Antwort an den Client senden
if (!$file == "") {
  // Pfad und Datei zerlegen...
  $info = pathinfo($file);
  if ($info['dirname'] != "")
	$info['dirname'] .= "/";
	
  // Mime Typ und Verzeichnis ermitteln
  // fr jpg, jpeg, gif, css und js
  switch(strtolower($info["extension"])) {
	case 'htc':
	$contentType = "text/x-component";
	$contentPath = "/css/".$info['dirname'];
	break;
	case 'jpg':
	$contentType = "image/jpeg";
	$contentPath = "/images/".$info['dirname'];
	break;
	case 'jpeg':
	$contentType = "image/jpeg";
	$contentPath = "/images/".$info['dirname'];
	break;
	case 'gif':
	$contentType = "image/gif";
	$contentPath = "/images/".$info['dirname'];
	break;
	case 'css':
	$contentType = "text/css";
	$contentPath = "/css/".$info['dirname'];
	break;
	case 'js':
	$contentType = "application/x-javascript";
	$contentPath = "/js/".$info['dirname'];
	break;
  }
  // teste ob die Datei berhaupt vorhanden ist
  if (file_exists($basis."/applications/".$application.$contentPath.$info["basename"])) {
	// Datei an den client senden
	header("Content-type: ".$contentType);
	readfile($basis."/applications/".$application.$contentPath.$info["basename"]);
	// und script beenden
	die();
  }
  elseif (!file_exists($basis."/system".$contentPath.$info["basename"])) {
	// falls nicht -> Fehlercode 404
	header("Status: 404");
	echo "<h1>Error: 404 - File not found</h1>";
	echo "The file '".$info["basename"]."' was not found on this server";
	// und script beenden
	die();
  }
  // Datei an den client senden
  header("Content-type: ".$contentType);
  readfile($basis."/system".$contentPath.$info["basename"]);
  // und script beenden
  die();
}


// ----------------------------------------
// Sofern keine Datei angefordert wurde
// geht es jetzt weiter
// ----------------------------------------

$dbPath = $basis."/applications/".$application."/db/";


// Autoload funktion erstellen (einfacher prototyp!) ##auslagern##
function _autoload($name) {


  GLOBAL $application;
  GLOBAL $basis;


  // Workaround:
  // PHP zeigt Syntaxfehler bei Includes welche ber _autoload geladen werden
  // nicht an sondern bricht ohne jede Fehlermeldung ab.
  //
  // erzeuge daher beim _autoload eine tmp-Datei in welcher der
  // letzt Versuch eine Datei zu laden gespeichert wird.
  //
  $myFile = $basis."/applications/".$application."/error/error.tmp";
  $fh = fopen($myFile, 'w');
  $loadfile = '';


  $loadfile = $basis."/system/yadev4php/".$name.".php";
  if (file_exists($loadfile)) {
	// merke dir den Ladevorgang
	fwrite($fh, "<? include_once '".$loadfile."' ?>\n");
	@include_once $loadfile;
  }
  if (! class_exists($name, false)) {
	$loadfile = $basis."/system/models/".$name.".php";
	if (file_exists($loadfile)) {
	  // merke dir den Ladevorgang
	  fwrite($fh, "<? include_once '".$loadfile."' ?>\n");
	  @include_once $loadfile;
	}
	if (! class_exists($name, false)) {
	  $loadfile = $basis."/system/controls/".$name.".php";
	  if (file_exists($loadfile)) {
		// merke dir den Ladevorgang
		fwrite($fh, "<? include_once '".$loadfile."' ?>\n");
		@include_once $loadfile;
	  }
	  if (! class_exists($name, false)) {
		$loadfile = $basis."/system/helper/".$name.".php";
		if (file_exists($loadfile)) {
		  // merke dir den Ladevorgang
		  fwrite($fh, "<? include_once '".$loadfile."' ?>\n");
		  @include_once $loadfile;
		}
		if (! class_exists($name, false)) {
		  $loadfile = $basis."/applications/".$application."/models/".$name . ".php";
		  if (file_exists($loadfile)) {
			// merke dir den Ladevorgang
			fwrite($fh, "<? include_once '".$loadfile."' ?>\n");
			@include_once $loadfile;
		  }
		  if (! class_exists($name, false)) {
			$loadfile = $basis."/system/dbDriver/".$name . ".php";
			if (file_exists($loadfile)) {
			  // merke dir den Ladevorgang
			  fwrite($fh, "<? include_once '".$loadfile."' ?>\n");
			  @include_once $loadfile;
			}
			if (! class_exists($name, false)) {
			  eval('class ' . $name . ' { ' .
			   '	public function __construct() { ' .
			   '		throw new Exception("Class ' . $name . ' not found."); ' .
			   '	} ' .
			   '} ');
			}
		  }
		}
	  }
	}
  }
  fwrite($fh, "Include war erfolgreich\n");
  @fclose($fh);


  return;
}

// teste, ob der _autoload Vorgang abgebrochen wurde
// Wenn ja, dann ist eine tmp-Datei vorhanden.
if (file_exists($basis."/applications/".$application."/error/error.tmp")) {

  $fh = fopen($basis."/applications/".$application."/error/error.tmp", 'r');
  $code = fgets($fh);
  $rest = fgets($fh);
  fclose($fh);
  if ($rest == "" && $code != "Include war erfolgreich\n") {
	$fh = fopen($basis."/applications/".$application."/error/error.php", 'w');
	fwrite($fh,$code."\n");
	fclose($fh);
	// Datei ber include und nicht ber _autoload einbinden.
	// Damit werden die Fehler auch angezeigt.
	include $basis."/applications/".$application."/error/error.php";
	unlink($basis."/applications/".$application."/error/error.php");
  }
}

spl_autoload_register('_autoload');


// -----------------------------------------------------------------------------
// 1. Den Controller laden
// -----------------------------------------------------------------------------
// Teste ob die Controller-Datei existiert und lade diese
if (file_exists($basis."/applications/".$application."/controllers/".$controller.".php")) {
  require_once $basis."/applications/".$application."/controllers/".$controller.".php";
}
elseif (file_exists($basis."/system/controllers/".$controller.".php")) {
  require_once $basis."/system/controllers/".$controller.".php";
}
else {
  // wenn die Controller-Datei nicht existiert, so gebe eine Fehlermeldung aus
  header("Status: 404");
  echo "<h1>Error: 404 - Controller not found</h1>";
  echo "The controller '".$controller."' was not found in application: '".$application."'";
  die();
}


// -----------------------------------------------------------------------------
// 2. Controller Objekt anlegen
// -----------------------------------------------------------------------------
try {
  $app = new $controller;
}
catch (Exception $e) {
  header("Status: 404");
  echo "<h1>Error: 404 - Controllerobject not found</h1>";
  echo "The controller '".$controller."' was not found in the sourcefile";
  die();
}

// berprfe ob das Controller Objekt ein Kind der richtigen
// Basisklasse ist (adev4php_controller)
$a = class_parents($app);
if ($a["yadev4php_controller"] == "") {
  header("Status: 404");
  echo "<h1>Error: 404 - Object is not an controller</h1>";
  echo "The object '".$controller."' is not an controller object";
  die();
}

// -----------------------------------------------------------------------------
// 3. Die init Methode aufrufen sofern die
// Methode aus dem Pfad nicht mit "_" beginnt
// -----------------------------------------------------------------------------
if (method_exists($app,"init")) {
  // init nicht aufrufen, falls die Methode mit einem underscore beginnt
  if (substr($method,0,1) != "_") {
	$app->init();
  }
}
else {
  header("Status: 404");
  echo "<h1>Error: 404 - Init() Method not found</h1>";
  echo "The controller '".$controller."' has no method called init()";
  die();
}

// -----------------------------------------------------------------------------
// 4. Die bergebene Methode aufrufen
// -----------------------------------------------------------------------------
if (method_exists($app,$method)) {
  $app->$method();
}
else {
  header("Status: 404");
  echo "<h1>Error: 404 - Method not found</h1>";
  echo "The controller '".$controller."' has no method called '".$method."()'";
  die();
}

function getController() {
GLOBAL $app;
  return $app;
}

function getAppPath() {
  GLOBAL $basis;
  GLOBAL $application;

  return $basis."/applications/".$application."/";
}

function getBasisPath() {
  GLOBAL $basis;
  
  return $basis."/";
}

function getConfig($var) {
  eval ("GLOBAL \$$var;");
  eval("\$d=\"\$$var\";");
  return $d;
}


function traceLog($log) {
	return false;
	$fh = fopen(getAppPath()."/logs/tace.log", 'a');
	fwrite($fh,$log."\r\n");
	fclose($fh);
}
?>
