<?

class dbDriver_dblib extends dbDriver {

  public $driver="dblib";

  public function open($hostname="", $database="", $user="", $password="") {
    GLOBAL $config_db;
  
    $hostname= $config_db["Location"];
    if ($database == "")  $database = $config_db["Database"];
    $user = $config_db["User"];
    $password = $config_db["Password"];
    
    
    try {
      $dbh = new PDO ("dblib:host=$hostname;dbname=$database","$user","$password");
    }
    catch(PDOException $e) {
      throw $e;
    }
    $this->dbHandle = $dbh;
    return true;
  }
  

  public function lastInsertID() {
    $sql = "SELECT @@IDENTITY AS mixLastId";
    $result = $this->select($sql);
    foreach ($result as $row) {
      $lid = $row[0];
      $lid = preg_replace('/[,.]0+$/', '', $lid);
      $lid = preg_replace('/[,.]/', '', $lid);
      return $lid;
    }
  }


  public function cleanSQL($sql) {

    $sql = str_replace(", ''",", NULL",$sql);
    $sql = str_replace("= ''","= NULL",$sql);
    
    $sql = str_replace("\'","''",$sql);
    $sql = str_replace('\"','"',$sql);

    $sql = $this->latin1UTF8->mixed_to_latin1($sql);

    return $sql;
  }


  public function getTableFields($table) {
    $r = Array();
    $result = $this->select("select COLUMN_NAME from INFORMATION_SCHEMA.COLUMNS where TABLE_NAME like '".$table."';");
    foreach ($result as $row) {
      $r[$row[0]] = $row[0];
    }
    return $r;
  }

  
  public function getTableNames() {
    $result = $this->select("select TABLE_NAME from INFORMATION_SCHEMA.TABLES;");
    foreach ($result as $row) {
        $b[$row[0]] = $row[0];
    }
    return $b;
   }
  
  
  public function tableExists($table) {
    $sql = "SELECT count(*) FROM INFORMATION_SCHEMA.TABLES where TABLE_NAME like '$table'";
    $result = $this->select($sql);
    $a = $result->fetchAll();
    return ($a[0][0] != 0);
  }


  private function buildCreateField($field) {
    // bersetzungstabelle fr die datentypen
    $ttype = array("string" => "varchar",
                   "password" => "varchar",
                   "text" => "text",
                   "date" => "datetime",
                   "datetime" => "datetime",
                   "time" => "time",
                   "blob" => "image",
                   "integer" => "int",
                   "num" => "numeric",
                   "currency" => "real",
                   "real" => "real");

    // setzte Namen und Typ
    $sql = $field->name."  ".$ttype[strtolower($field->type)];
    // wenn eine Size Angabe existiert, dann gebe die Gre an
    // eigentlich nur fr String und Num sinnvoll. sollte man berprfen
    if ($field->size != "")
      $sql .= "(".$field->size.")";
    elseif (strtolower($field->type) == "string")
      $sql .= "(255)";
    // wenn das Feld der primaryKey ist...
    if (strtolower($field->index) == "primarykey") {
      // und es ein Autowert Feld ist (nur fr integer sinnvoll!) oder nicht:
      if (strtolower($field->value) == "auto")
        $sql .= " IDENTITY(1,1)PRIMARY KEY NOT NULL";
      else
        $sql .= " PRIMARY KEY NOT NULL ";
    }
    // 'normale' Felder
    else {
      // teste, ob ein Standardwert angegeben ist
      if ($field->value != "")
        $sql .= " DEFAULT '".$field->value."'";
      $tnull = false;
      if (isset($field->validate)) {
        foreach ($field->validate as $val) {
          if (strtolower($val) == "notnull()") {
            $tnull = true;
            $sql .= " NOT NULL";
          }
        }
      }
      if (!$tnull) $sql .= " NULL";
    }
    //$sql = str_replace("  ", " ", $sql);
    //$sql = substr($sql,0,-1);
    return $sql;
  }
  

  public function buildAddColumn($table, $field) {
    $sql = "ALTER TABLE ".$table."\nADD ";
    $sql .= $this->buildCreateField($field).";";
    return $sql;
  }
  
  
  public function buildCreateTable($table,$fields) {
    // sammle Felder fr index (implementierung erfolgt spter)
    $index = array();
    
    // beginne mit dem Erstellen der SQL Befehle...
    $sql = "CREATE TABLE ".$table." (\n";
    // durchlaufe alle vorhandenen Felder
    foreach ($fields as $field) {
      $sql .= $this->buildCreateField($field).",\n";
      if ($field->index != "")
        $index[strtolower($field->index)][] = $field->name;
    }
    $sql = substr($sql,0,-2)."\n);\n";
    return $sql;
  }


  public function getSelect($model, $short=false) {
     $r = "";
     $a = $model->_getFields();
     foreach ($a as $field) {
       $r = $r.", ".$model->getName().".".$field->name." AS '".$model->getName().".".$field->name."'";
     }
     $r = substr($r,1);
     return $r;
  }



  public function dateToDb($date, $dt=false) {
	 // convert date into ISO/DB format (yyyymmdd)
	 list($d ,$t) = explode(' ', $date, 2);
	 list($day, $month, $year) = split('[/.-]', $d);
	 $date =  trim($year.$month.$day, " ");
	 if ($dt) trim($date = $date." ".$t, ' ');
	 return $date;
  }
  

  public function dateFromDb($date, $dt = false) {

	// convert any valid date format into german date (dd.mm.yyyy)

        // Convert german monthnames into english
        $s = array('Mr','Mär','Mrz','Mai','Okt','Dez');
        $e = array('Mar','Mar','Mar','May','Oct','Dec');
        $date = str_replace($s,$e,$date);
	
        if ($date != "") {
	  $r = date_parse($date);
	  $date = str_pad($r['day'],2,'0',STR_PAD_LEFT).".".str_pad($r['month'],2,'0',STR_PAD_LEFT).".".str_pad($r['year'],4,'0',STR_PAD_LEFT);
          
          // if with Time then	
          if ($dt) $date .= " ".str_pad($r['hour'],2,'0',STR_PAD_LEFT).":".str_pad($r['minute'],2,'0',STR_PAD_LEFT).":".str_pad($r['second'],2,'0',STR_PAD_LEFT);
	}

	if ($date == "00.00.0000") $date = "";  // erase date
//	if ($r['error_count'] > 0) $date = "";  // erase date

	return $date;
  }



  public function select($sql,$offset=0,$limit=0) {


    $sql=$this->cleanSQL($sql); 



    if ($limit > 0) {
      $sql = str_replace('SELECT ','SELECT TOP '.($offset+$limit).' identity(int,1,1) as myNo,', $sql);
      $sql = str_replace(' FROM ',' INTO #tmp FROM ', $sql);

      $count = $this->dbHandle->exec($sql);
      $sql = 'SELECT * FROM #tmp WHERE myNo > '.$offset; //.' AND myNo < '.($offset+$limit+1); 
    }

    try {
       $recordset = $this->dbHandle->query($sql);
       return $recordset;
    }
    catch(PDOExeption $e) {
      echo "Datenbank Fehler in SQL String ".$sql;
      throw $e;
    }

  }


  
//
// ******** old version without time *********
//  
//  public function dateToDb($date) {
//     // convert date into ISO/DB format (yyyymmdd)
//     list($day, $month, $year) = split('[/.-]', $date);
//     $date =  trim($year.$month.$day, " ");
//     return $date;
//  }
  
//  public function dateFromDb($date) {
//    // convert any valid date format into german date (dd.mm.yyyy)
//    if ($date != "") {
//      $r = date_parse($date);
//      $date = str_pad($r['day'],2,'0',STR_PAD_LEFT).".".str_pad($r['month'],2,'0',STR_PAD_LEFT).".".str_pad($r['year'],4,'0',STR_PAD_LEFT);
//    }
//    if ($date == "00.00.0000") $date = "";
//    return $date;
//  }
  
}

?>
