<?


class dbDriver_sqlite3 extends dbDriver {

  public $driver="sqlite";
 
  public function open($cstring = "") {
	GLOBAL $config_db;
	$cstring = "sqlite:".$config_db["Location"].$config_db["Database"];
	$this->$cstring = $cstring;
	try {
	  if (substr($cstring,0,7) != 'sqlite:') {
		$cstring = 'sqlite:'.$cstring;
	  }

	  $dbh = new PDO($cstring);
	}
	catch(PDOException $e) {
	  throw $e;
	}
	$this->dbHandle = $dbh;
	//$this->dbHandle->setAttribute(PDO::ATTR_ERRMODE, PDO::ERRMODE_WARNING);
	$this->dbHandle->exec("PRAGMA full_column_names = true;");
	$this->dbHandle->exec("PRAGMA short_column_names = false;");
	$this->dbHandle->exec("PRAGMA synchronous =  0;");
	return true;
  }
  
  
  public function lastInsertID() {
	return $this->dbHandle->lastInsertId();
  }

  public function cleanSQL($sql) {
	$sql = str_replace("\\'","''",$sql);
	$sql = str_replace("\\\"","\"",$sql);
	$sql = str_replace("\\\\","\\",$sql);
	// fix encoding to UTF-8
	$sql = utf8_encode($sql);
	return $sql;
  }
  
  
  public function getTableFields($table) {
	$r = Array();
	$result = $this->select("PRAGMA table_info(".$table.");");
	foreach ($result as $row) {
	  $r[$row[1]] = $row[1];
	}
	return $r;
  }
  
  public function getTableNames() {
	$sql = "SELECT name FROM SQLITE_MASTER WHERE type like 'table'".
		   " and not name like 'sqlite_sequence'";
	$result = $this->select($sql);
	foreach ($result as $row) {
	  $b[$row[0]] = $row[0];
	}
	return $b;
   }
  
  
  public function tableExists($table) {
	$sql = "SELECT count(*) FROM SQLITE_MASTER WHERE type like 'table' and name like '$table'";
	//$result = $this->dbHandle->query($sql);
	$result = $this->select($sql);
	$a = $result->fetchAll();
	return ($a[0][0] != 0);
  }


  private function buildCreateField($field) {
	// bersetzungstabelle fr die datentypen
	$ttype = array("string" => "varchar",
				   "password" => "varchar",
				   "text" => "text",
				   "date" => "date",
				   "datetime" => "datetime",
				   "time" => "time",
				   "blob" => "blob",
				   "integer" => "integer",
				   "num" => "numeric",
				   "currency" => "real",
				   "real" => "real",
				   "boolean" => "integer");

	// setzte Namen und Typ
	$sql = $field->name."  ".$ttype[strtolower($field->type)];
	// wenn eine Size Angabe existiert, dann gebe die Gre an
	// eigentlich nur fr String und Num sinnvoll. sollte man berprfen
	if ($field->size != "")
	  $sql .= "(".$field->size.")";
	// wenn das Feld der primaryKey ist...
	if (strtolower($field->index) == "primarykey") {
	  // und es ein Autowert Feld ist (nur fr integer sinnvoll!) oder nicht:
	  if (strtolower($field->value) == "auto")
		$sql .= " PRIMARY KEY AUTOINCREMENT NOT NULL";
	  else
		$sql .= " PRIMARY KEY NOT NULL ";
	}
	// 'normale' Felder
	else {
	  // teste, ob ein Standardwert angegeben ist
	  if ($field->value != "")
		$sql .= " DEFAULT '".$field->value."'";
	  if (isset($field->validate)) {
		foreach ($field->validate as $val) {
		  if (strtolower($val) == "notnull()")
			$sql .= " NOT NULL";
		}
	  }
	}
	//$sql = str_replace("  ", " ", $sql);
	//$sql = substr($sql,0,-1);
	return $sql;
  }
  

  public function buildAddColumn($table, $field) {
	$sql = "ALTER TABLE ".$table."\nADD COLUMN ";
	$sql .= $this->buildCreateField($field).";";
	return $sql;
  }
  
  
  public function buildCreateTable($table,$fields) {
	// bersetzungstabelle fr die datentypen
	$ttype = array("string" => "varchar",
				   "password" => "varchar",
				   "text" => "text",
				   "date" => "date",
				   "datetime" => "datetime",
				   "time" => "time",
				   "blob" => "blob",
				   "integer" => "integer",
				   "num" => "numeric",
				   "currency" => "real",
				   "real" => "real");
				   
	// sammle Felder fr index (implementierung erfolgt spter)
	$index = array();
	
	// beginne mit dem Erstellen der SQL Befehle...
	$sql = "CREATE TABLE ".$table." (\n";
	// durchlaufe alle vorhandenen Felder
	foreach ($fields as $field) {
	  $sql .= $this->buildCreateField($field).",\n";
	  if ($field->index != "")
		$index[strtolower($field->index)][] = $field->name;
	}
	$sql = substr($sql,0,-2)."\n);\n";
	return $sql;
  }
  
  
  
  public function getSelect($model, $short) {
	 $r = "";
	 if ($short) {
	   $r = $model->_name.".* ";
	 }
	 else  {
	   $a = $model->_getFields();
	   foreach ($a as $field) {
		 $r = $r.", ".$field->name;
	   }
	   $r = substr($r,1);
	 }
	 return $r;
  }

  // $date = Datum $dt = DateTime Format?
  public function dateToDb($date, $dt = false) {
	 if ($date != '') {
	   if (strpos($date, ' ') === false) {
		 $date .= " 00:00:00";
	   }
	   list($d ,$t) = explode(' ', $date, 2);
	   list($day, $month, $year) = preg_split('/[\/\.-]/', $d);
	   $date =  trim($year.'-'.$month.'-'.$day, "-");
	   if ($dt) trim($date = $date." ".$t, ' ');
	 }
	 return $date;
  }


  public function currencyFromDb($c) {
	return number_format($c, 2, ',', '.');
  }

  public function currencyToDb($str) {
		if(strpos($str, '.') < strpos($str,',')){
			$str = str_replace('.','',$str);
			$str = strtr($str,',','.');		   
		}
		else{
			$str = str_replace(',','',$str);		   
		}
		return (float)$str;
  } 


  public function dateFromDb($date, $dt = false) {
	 if ($date != '' ) {
	   if (strpos($date, ' ') === false) {
		 $date .= " 00:00:00";
	   }
	   list($d ,$t) = explode(' ', $date, 2);
	   list($year, $month, $day) = preg_split('/[\/\.-]/', $d);
	   if ($t.'' == '') {
		 $t = '00:00:00';
	   }
	   if ($dt)
		 return trim($day.".".$month.".".$year.' '.$t, ".");
	   else
		 return trim($day.".".$month.".".$year, ".");
	 }
	 else
	   return '';
  }

  public function select($sql,$offset=0,$limit=0) {

	$sql=$this->cleanSQL($sql); 

	if ($limit > 0)
	  $sql = $sql." limit ".$offset.",".$limit;
 
	try {
	   $recordset = $this->dbHandle->query($sql);
	   return $recordset;
  // var_dump($recordset);
	}
	catch(PDOExeption $e) {
	  echo "Datenbank Fehler in SQL String ".$sql;
	  throw $e;
	}
  }

}

?>
