<?

class yadev4php_join implements Iterator{
  private $_name;                       // Name des Objektes

  private $_hooks = Array();            // Hooks - Objekte z.B. masterDetail
  private $_controlls = Array();        // bind controlls
  private $_joins = Array();
  private $_result;

  public $_db;                          // Database Class
  public $valid;                        // Sind Daten geladen worden
  public $numRecords;
  public $pagesize;
  



  //
  // Iterator Funktionen
  //
  public function rewind() {
    $this->_index = -1;
    $this->moveNext();
  }

  public function current() {
    return $this;
  }

  public function key() {
    // wird nicht bentigt - nicht implementiert
  }

  public function next() {
    $this->moveNext();
    return $this;
  }

  public function valid() {
    return $this->valid;
  }


  public function addModel($object,$on = "", $type = "LEFT JOIN") {
    $j = new join();
    $j->object = $object;
    $j->name = strtolower($object->getName());
    $j->type = $type;
    $j->on = $on;
    $this->_joins[$j->name] = $j;
  }
  

  private function _getSQLRecordCount($where) {
    $select = 'SELECT count(*) as anzahl ';
    $join = "";
    foreach ($this->_joins as $j) {
      if ($j->on != "") {
        $join .= " ".$j->type." ".$j->object->_getFrom()." ON ".$j->on." ";
      }
      else {
        $from = "FROM ".$j->object->_getFrom();
      }
    }
    $r = $select." ".$from." ".$join;
    if ($where != "") $r .= " where ".$where;
    return $r;
  }

  private function _getSQLPage($id, $offset, $where) {
    $select = 'SELECT MAX(ofs) as start from (SELECT ';
    $join = "";
    $select .= 'top '.$offset.' '.$id.' as ofs ';
    foreach ($this->_joins as $j) {
      if ($j->on != "") {
        $join .= " ".$j->type." ".$j->object->_getFrom()." ON ".$j->on." ";
      }
      else {
        $from = "FROM ".$j->object->_getFrom();
      }
    }
    $r =  $select." ".$from." ".$join;
    if ($where != "") $r .= " where ".$where;
    $r .= " order by ".$id.") as tmp_table;";
    return $r;
  }

  private function _getSQL($pagesize=0) {
    $select = "SELECT ";
    $join = "";
    foreach ($this->_joins as $j) {
      $select .= $j->object->_getSelect(true).", ";
      if ($j->on != "") {
        $join .= " ".$j->type." ".$j->object->_getFrom()." ON ".$j->on." ";
      }
      else {
        $from = "FROM ".$j->object->_getFrom();
      }
   }
    $select = substr($select,0,-2);
    
    return $select." ".$from." ".$join;
  }
    

  private function _getSQLFrom() {
    $join = "";
    $from = "";
    foreach ($this->_joins as $j) {
      if ($j->on != "") {
        $join .= " ".$j->type." ".$j->object->_getFrom()." ON ".$j->on." ";
      }
      else {
        $from = "FROM ".$j->object->_getFrom();
      }
   }
   return $from." ".$join;
  }

  public function property_exists($dt){
    // zerlege $dt in Model und Field
    $a = explode("_x_", $dt,2);
    if (count($a) == 2) {
      $model = $a[0];
      $field = $a[1];
	  if (!isSet($this->_joins[$model]))
        return false;

      return $this->_joins[$model]->object->property_exists($field);
	}
    return false;
  }	
  //
  // Setzte den Wert einer Variablen
  //
  public function __set($dt, $vl) {
    // zerlege $dt in Model und Field
    $a = explode("_x_", $dt,2);
    if (count($a) == 2) {
      $model = $a[0];
      $field = $a[1];

      if (!isSet($this->_joins[$model]))
       throw new Exception("Cannot assign values to undefined model:".$model,1);

      $this->_joins[$model]->object->$field = $vl;
    }
    else {
      if ($dt != '') $this->$dt = $vl;
    }
  }

  //
  // Lese den Wert einer Variablen
  //
  public function __get($dt) {
    // zerlege $dt in Model und Field
    $a = explode("_x_",$dt,2);
    $model = $a[0];
    $field = $a[1];

    if (count($a) == 2) {
      if (!isSet($this->_joins[$model]))
        throw new Exception("Cannot get values from undefined model:".$model,2);

      $val = $this->_joins[$model]->object->$field;
    }
    else {
      $val = $this->$dt;
    }
    
    if (method_exists($this,"filter_get")) {
       $val = $this->filter_get($dt,$val);
    }
    return $val;
  }


  public function _setProperties($a) {
    $r = Array();
    foreach ($a as $key => $value) {
      if (!strpos($key,".") === false) {
        $a = split("\.",$key);
        $object = strtolower($a[0]);
        $key = $a[1];
      }
	  if ($key != 'myNo')
        $r[$object][$key] = $value;
    }
    foreach ($r as $key => $value) {
      $this->_joins[$key]->object->_setProperties($value,true);
    }
  }

  public function moveNext() {
    $this->_index++;
    if ($this->_index < (count($this->_result))) {
      $this->_setProperties($this->_result[$this->_index], true);
      $this->valid = true;
    }
    else {
      $this->valid = false;
    }
    if ($this->valid) {
      // Teste ob Hook Objekte fr diese Methode eingehngt wurden
      // (z.B. ein masterDetail Objekt)
      if (isset($this->_hooks["loadObject"])) {
        foreach ($this->_hooks["loadObject"] as $hook) {
          $hook->hook_loadObject($this);
        }
      }

      // Teste, ob es eine globale Funktion mit entsprechender
      // Bezeichnung gibt und rufe diese dann auf
      $c = "onLoadObject_".$this->_name;
      if (function_exists($c)) {
        $c($this);
      }
    }
    return $this->valid;
  }


  //
  // Lade ein Object aus der DB nach der Where Klausel
  //
  public function loadModelByWhere($where="", $order="", $page=0, $limit=0) {

    $offset = $page * $limit;

    $this->pagesize = $limit;

    // Zu erst die Anzahl der Datenstze ermitteln....
    $sql = $this->_getSQLRecordCount($where);
    $this->_result = $this->_db->select($sql);
    $this->_result = $this->_result->fetchAll(PDO::FETCH_ASSOC);
    $this->numRecords = $this->_result[0]['anzahl'];
      
    // Danach die Daten abfragen, unter Bercksichtigung von Paging Paramtern

    // SQL String aufbauen und um Where und order ergnzen
    $sql = $this->_getSQL($limit);
    if ($where != "")
      $sql .= " WHERE ".$where;

    if ($order != "")
      $sql .= " ORDER BY ".$order;

    // Abfrage ber db-Treiber durchfhren (Dieser bercksichtigt offset und limit!)
    $this->_result = $this->_db->select($sql, $offset, $limit);
    if (!$this->_result === false) {
      $this->_result = $this->_result->fetchAll(PDO::FETCH_ASSOC);
      $this->_index = -1;
      return $this->moveNext();
    }
    else {
      throw new Exception (implode(" - ",$this->_db->errorInfo()));
    }
  }

  //installiere ein Hook Objekt
  public function _addHook($hook, $object) {
    $this->_hooks[$hook][] = $object;
  }

  public function bindControl($control, $field) {
    if (!property_exists($this,$field))
      throw new Exception("Cannot bind control to undefined property:".$field,1);
    $this->_controlls[$field][] = $control;
  }


  public function __construct($n) {
    $this->_name = $n;
    // Erstelle das Datenbankobjekt
    GLOBAL $config_db;
    $dbd = $config_db["Driver"];
    $this->_db = new $dbd();
//    $this->_db = new dbDriver_sqlite3();
//    $this->_db = new dbDriver_mssql();

    // model zur collection aller Models hinzufgen
    $app = getController();
    $app->models[$n] = $this;

  }

}

class join {
  public $object;
  public $name;
  public $type;
  public $on;
}

?>
